//przykladowa implementacja quicksort'u

#include<cstdio>
#include<cstdlib>
#include<iostream>
#include<iomanip>

const int maxsize = 9;

using namespace std;

void swap(int *t, int i, int j){
	int pom=t[i];
     t[i]=t[j];
	t[j]=pom;
}

void printing(int *t, int size){
	cout<<endl;
	for(int i=0;i<size;i++)
	cout<<t[i]<<", ";
}



int partition(int*, int, int);
void _quicksort(int*, int,int);
void quicksort(int*, int);

int test(); //funkcja testujaca poprawnosc sortowana

int main(void){
	srand(time(NULL)); //startujemy generator liczb pseudolosowych dla funkcji test()	
	if(test()==0) 
		cout<<endl<<"Blad algorytmu sortowania"; //testowanie
	int t[maxsize]={7,3,4,5,1,4,9,8,13};
	cout<<endl;
	for(int i=0;i<maxsize;i++)
		cout<<t[i]<<", ";
	quicksort(t,maxsize);
	cout<<endl;
	for(int i=0;i<maxsize;i++)
		cout<<t[i]<<", ";
	cout<<endl<<flush;
	system("read -p \"Press [Enter]\" "); //Linux
	//system("pause"); //DOS
	return 1;
}



int partition(int *t, int lewy, int prawy){
	int v=t[prawy];
	int i=lewy-1, j=prawy;
	if(lewy>=prawy)
		return prawy;
	while(i<j){
	   do{ i++;}while(t[i]<v && i<j); 
	   do{ j--;}while(t[j]>v && i<j); 
	   if(i<j) 
	     swap(t,i,j);
	}
	swap(t,prawy,i);
	return i;
}


//sortuje tablice t[lewy, ...,prawy]

void _quicksort(int *t, int lewy, int prawy){
	if(lewy>=prawy)
		return;
	int i=partition(t,lewy,prawy);
	//nastepna linijka kodu wypisuje tablice po wykonaniu partition()
	//tylko dla ilustracji dzialania programu
	printing(t,maxsize); cout<<"[l,i,p]=["<<lewy<<", "<<i<<", "<<prawy<<"], t[i]="<<t[i];
	_quicksort(t,lewy, i-1);
	_quicksort(t,i+1,prawy);
}


//sortuje tablice t[0,...,size-1]

void quicksort(int *t, int size){
	_quicksort(t,0,size-1);
}


int test(){
	int t[30];
	for(int i=0;i<=50;i++){
		for(int k=0;k<30;k++)     //testujemy quicksort
			t[k]=rand()%50;
		quicksort(t,30);
		for(int j=0;j<29;j++)
			if(t[j]>t[j+1]){
				cout<<"Blad: ";
				printing(t,30);
				return 0; // tablica nie zostala posortowana
			}

	}
	return 1; // wszystko poszlo dobrze
}